# CfnDataSet

Creates a dataset.

This operation doesn't support datasets that include uploaded files as a source.

Extends: Construct › CfnElement › CfnRefElement › CfnResource › CfnDataSet
Implements: IInspectable, ITaggable, IEnvironmentAware, IDataSetRef, IConstruct, IDependable

- CloudFormation: [`AWS::QuickSight::DataSet`](https://docs.aws.amazon.com/AWSCloudFormation/latest/TemplateReference/aws-resource-quicksight-dataset.html)
- Source: Generated code
- Type last changed: v2.252.0 · 30 Apr 2026

## Example

```ts
// The generated example for this type would exceed 500 lines,
// and has been elided for readability.
```

## Initializer

```ts
new CfnDataSet(scope: Construct, id: string, props?: CfnDataSetProps)
```

## Construct Props

- `awsAccountId`: string — The AWS account ID.

- `columnGroups`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnDataSet.ColumnGroupProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_quicksight.CfnDataSet.ColumnGroupProperty.html)[] — Groupings of columns that work together in certain Amazon Quick Sight features.

  Currently, only geospatial hierarchy is supported.

- `columnLevelPermissionRules`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnDataSet.ColumnLevelPermissionRuleProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_quicksight.CfnDataSet.ColumnLevelPermissionRuleProperty.html)[] — A set of one or more definitions of a `ColumnLevelPermissionRule` .

- `dataPrepConfiguration`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnDataSet.DataPrepConfigurationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_quicksight.CfnDataSet.DataPrepConfigurationProperty.html) — The data preparation configuration associated with this dataset.

- `dataSetId`: string — An ID for the dataset that you want to create.

  This ID is unique per AWS Region for each AWS account.

- `datasetParameters`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnDataSet.DatasetParameterProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_quicksight.CfnDataSet.DatasetParameterProperty.html)[] — The parameters that are declared in a dataset.

- `dataSetRefreshProperties`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnDataSet.DataSetRefreshPropertiesProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_quicksight.CfnDataSet.DataSetRefreshPropertiesProperty.html) — The refresh properties of a dataset.

- `dataSetUsageConfiguration`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnDataSet.DataSetUsageConfigurationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_quicksight.CfnDataSet.DataSetUsageConfigurationProperty.html) — The usage configuration to apply to child datasets that reference this dataset as a source.

- `fieldFolders`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | { [key: string]: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnDataSet.FieldFolderProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_quicksight.CfnDataSet.FieldFolderProperty.html) } — The folder that contains fields and nested subfolders for your dataset.

- `folderArns`: string[] — <p>When you create the dataset, Amazon QuickSight adds the dataset to these folders.</p>.

- `importMode`: string — Indicates whether you want to import the data into SPICE.

- `ingestionWaitPolicy`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnDataSet.IngestionWaitPolicyProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_quicksight.CfnDataSet.IngestionWaitPolicyProperty.html) — The wait policy to use when creating or updating a Dataset.

  The default is to wait for SPICE ingestion to finish with timeout of 36 hours.

- `logicalTableMap`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | { [key: string]: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnDataSet.LogicalTableProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_quicksight.CfnDataSet.LogicalTableProperty.html) } — this property has been deprecated

- `name`: string — The display name for the dataset.

- `performanceConfiguration`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnDataSet.PerformanceConfigurationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_quicksight.CfnDataSet.PerformanceConfigurationProperty.html) — The performance optimization configuration of a dataset.

- `permissions`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnDataSet.ResourcePermissionProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_quicksight.CfnDataSet.ResourcePermissionProperty.html)[] — A list of resource permissions on the dataset.

- `physicalTableMap`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | { [key: string]: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnDataSet.PhysicalTableProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_quicksight.CfnDataSet.PhysicalTableProperty.html) } — Declares the physical tables that are available in the underlying data sources.

- `rowLevelPermissionDataSet`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnDataSet.RowLevelPermissionDataSetProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_quicksight.CfnDataSet.RowLevelPermissionDataSetProperty.html) — this property has been deprecated

  The permissions dataset maps fields to users or groups. For more information, see
              <a href="https://docs.aws.amazon.com/quicksight/latest/user/restrict-access-to-a-data-set-using-row-level-security.html">Using Row-Level Security (RLS) to Restrict Access to a Dataset</a> in the <i>Amazon QuickSight User
                  Guide</i>.</p>
           <p>The option to deny permissions by setting <code>PermissionPolicy</code> to <code>DENY_ACCESS</code> is
              not supported for new RLS datasets.</p>

- `rowLevelPermissionTagConfiguration`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnDataSet.RowLevelPermissionTagConfigurationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_quicksight.CfnDataSet.RowLevelPermissionTagConfigurationProperty.html) — this property has been deprecated

  </p>

- `semanticModelConfiguration`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnDataSet.SemanticModelConfigurationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_quicksight.CfnDataSet.SemanticModelConfigurationProperty.html) — The semantic model configuration associated with this dataset.

- `tags`: [CfnTag](/cdk/api/v2/docs/aws-cdk-lib.CfnTag.html)[] — Contains a map of the key-value pairs for the resource tag or tags assigned to the dataset.

- `useAs`: string — The usage of the dataset.

## Properties

- `attrArn`: string — The Amazon Resource Name (ARN) of the dataset.

- `attrConsumedSpiceCapacityInBytes`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) — <p>The amount of SPICE capacity used by this dataset.

  This is 0 if the dataset isn't
              imported into SPICE.</p>

- `attrCreatedTime`: string — The time this dataset version was created.

- `attrLastUpdatedTime`: string — The time this dataset version was last updated.

- `attrOutputColumns`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) — <p>The list of columns after all transforms.

  These columns are available in templates,
              analyses, and dashboards.</p>

- `awsAccountId`: string — The AWS account ID.

- `CFN_RESOURCE_TYPE_NAME`: string (static) — The CloudFormation resource type name for this resource class.

- `cfnOptions`: [ICfnResourceOptions](/cdk/api/v2/docs/aws-cdk-lib.ICfnResourceOptions.html) — Options for this resource, such as condition, update policy etc.

- `cfnResourceType`: string — AWS resource type.

- `columnGroups`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnDataSet.ColumnGroupProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_quicksight.CfnDataSet.ColumnGroupProperty.html)[] — Groupings of columns that work together in certain Amazon Quick Sight features.

- `columnLevelPermissionRules`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnDataSet.ColumnLevelPermissionRuleProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_quicksight.CfnDataSet.ColumnLevelPermissionRuleProperty.html)[] — A set of one or more definitions of a `ColumnLevelPermissionRule` .

- `creationStack`: string[]

- `dataPrepConfiguration`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnDataSet.DataPrepConfigurationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_quicksight.CfnDataSet.DataPrepConfigurationProperty.html) — The data preparation configuration associated with this dataset.

- `dataSetId`: string — An ID for the dataset that you want to create.

- `datasetParameters`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnDataSet.DatasetParameterProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_quicksight.CfnDataSet.DatasetParameterProperty.html)[] — The parameters that are declared in a dataset.

- `dataSetRef`: [DataSetReference](/cdk/api/v2/docs/aws-cdk-lib.interfaces.aws_quicksight.DataSetReference.html) — A reference to a DataSet resource.

- `dataSetRefreshProperties`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnDataSet.DataSetRefreshPropertiesProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_quicksight.CfnDataSet.DataSetRefreshPropertiesProperty.html) — The refresh properties of a dataset.

- `dataSetUsageConfiguration`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnDataSet.DataSetUsageConfigurationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_quicksight.CfnDataSet.DataSetUsageConfigurationProperty.html) — The usage configuration to apply to child datasets that reference this dataset as a source.

- `env`: [ResourceEnvironment](/cdk/api/v2/docs/aws-cdk-lib.interfaces.ResourceEnvironment.html)

- `fieldFolders`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | { [key: string]: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnDataSet.FieldFolderProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_quicksight.CfnDataSet.FieldFolderProperty.html) } — The folder that contains fields and nested subfolders for your dataset.

- `folderArns`: string[] — <p>When you create the dataset, Amazon QuickSight adds the dataset to these folders.</p>.

- `importMode`: string — Indicates whether you want to import the data into SPICE.

- `ingestionWaitPolicy`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnDataSet.IngestionWaitPolicyProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_quicksight.CfnDataSet.IngestionWaitPolicyProperty.html) — The wait policy to use when creating or updating a Dataset.

- `logicalId`: string — The logical ID for this CloudFormation stack element.

  The logical ID of the element
  is calculated from the path of the resource node in the construct tree.

  To override this value, use `overrideLogicalId(newLogicalId)`.

- `logicalTableMap`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | { [key: string]: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnDataSet.LogicalTableProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_quicksight.CfnDataSet.LogicalTableProperty.html) } — this property has been deprecated

- `name`: string — The display name for the dataset.

- `node`: [Node](/cdk/api/v2/docs/constructs.Node.html) — The tree node.

- `performanceConfiguration`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnDataSet.PerformanceConfigurationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_quicksight.CfnDataSet.PerformanceConfigurationProperty.html) — The performance optimization configuration of a dataset.

- `permissions`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnDataSet.ResourcePermissionProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_quicksight.CfnDataSet.ResourcePermissionProperty.html)[] — A list of resource permissions on the dataset.

- `physicalTableMap`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | { [key: string]: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnDataSet.PhysicalTableProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_quicksight.CfnDataSet.PhysicalTableProperty.html) } — Declares the physical tables that are available in the underlying data sources.

- `ref`: string — Return a string that will be resolved to a CloudFormation `{ Ref }` for this element.

  If, by any chance, the intrinsic reference of a resource is not a string, you could
  coerce it to an IResolvable through `Lazy.any({ produce: resource.ref })`.

- `rowLevelPermissionDataSet`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnDataSet.RowLevelPermissionDataSetProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_quicksight.CfnDataSet.RowLevelPermissionDataSetProperty.html) — this property has been deprecated

- `rowLevelPermissionTagConfiguration`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnDataSet.RowLevelPermissionTagConfigurationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_quicksight.CfnDataSet.RowLevelPermissionTagConfigurationProperty.html) — this property has been deprecated

- `semanticModelConfiguration`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnDataSet.SemanticModelConfigurationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_quicksight.CfnDataSet.SemanticModelConfigurationProperty.html) — The semantic model configuration associated with this dataset.

- `stack`: [Stack](/cdk/api/v2/docs/aws-cdk-lib.Stack.html) — The stack in which this element is defined.

  CfnElements must be defined within a stack scope (directly or indirectly).

- `tags`: [TagManager](/cdk/api/v2/docs/aws-cdk-lib.TagManager.html) — Tag Manager which manages the tags for this resource.

- `tagsRaw`: [CfnTag](/cdk/api/v2/docs/aws-cdk-lib.CfnTag.html)[] — Contains a map of the key-value pairs for the resource tag or tags assigned to the dataset.

- `useAs`: string — The usage of the dataset.

## Methods

- `addDeletionOverride(path: string): void` — Syntactic sugar for `addOverride(path, undefined)`.

  **Parameters**

  - `path` — The path of the value to delete.

- `addDependency(target: CfnResource): void` — Use `addResourceDependency` instead.

  This method has been renamed to `addResourceDependency` to more clearly
  set it apart from `construct.node.addDependency`. See the documentation
  of that function for more details.

- `addDependsOn(target: CfnResource): void` — Use `addResourceDependency` instead.

  This can be used for resources across stacks (or nested stack) boundaries
  and the dependency will automatically be transferred to the relevant scope.

  This method has been renamed to `addResourceDependency`, which makes it
  more clear that this method operates at a different level from the
  construct-level `construct.node.addDependency()` mechanism.

- `addMetadata(key: string, value: any): void` — Add a value to the CloudFormation Resource Metadata.

- `addOverride(path: string, value: any): void` — Adds an override to the synthesized CloudFormation resource.

  To add a
  property override, either use `addPropertyOverride` or prefix `path` with
  "Properties." (i.e. `Properties.TopicName`).

  If the override is nested, separate each nested level using a dot (.) in the path parameter.
  If there is an array as part of the nesting, specify the index in the path.

  To include a literal `.` in the property name, prefix with a `\`. In most
  programming languages you will need to write this as `"\\."` because the
  `\` itself will need to be escaped.

  For example,
  ```typescript
  cfnResource.addOverride('Properties.GlobalSecondaryIndexes.0.Projection.NonKeyAttributes', ['myattribute']);
  cfnResource.addOverride('Properties.GlobalSecondaryIndexes.1.ProjectionType', 'INCLUDE');
  ```
  would add the overrides
  ```json
  "Properties": {
    "GlobalSecondaryIndexes": [
      {
        "Projection": {
          "NonKeyAttributes": [ "myattribute" ]
          ...
        }
        ...
      },
      {
        "ProjectionType": "INCLUDE"
        ...
      },
    ]
    ...
  }
  ```

  The `value` argument to `addOverride` will not be processed or translated
  in any way. Pass raw JSON values in here with the correct capitalization
  for CloudFormation. If you pass CDK classes or structs, they will be
  rendered with lowercased key names, and CloudFormation will reject the
  template.

  **Parameters**

  - `path` — - The path of the property, you can use dot notation to override values in complex types.
  - `value` — - The value.

- `addPropertyDeletionOverride(propertyPath: string): void` — Adds an override that deletes the value of a property from the resource definition.

  **Parameters**

  - `propertyPath` — The path to the property.

- `addPropertyOverride(propertyPath: string, value: any): void` — Adds an override to a resource property.

  Syntactic sugar for `addOverride("Properties.<...>", value)`.

  **Parameters**

  - `propertyPath` — The path of the property.
  - `value` — The value.

- `addResourceDependency(target: CfnResource, reason?: string): void` — Indicates that this resource depends on another resource and cannot be provisioned unless the other resource has been successfully provisioned.

  This can be used for resources across stacks (or nested stack) boundaries
  and the dependency will automatically be transferred to the relevant scope.

  This method only adds dependencies between L1 resources. If you are
  looking for a generic construct-to-construct dependency mechanism that works
  for all constructs including L2s, use `construct.node.addDependency` instead.

- `applyCrossStackReferenceStrength(strength: ReferenceStrength): void` — Sets the cross-stack reference strength for this resource.

  When set, any cross-stack reference to this resource will use the specified
  strength instead of the global default from the consuming stack's context.

  **Parameters**

  - `strength` — - The reference strength to use for this resource.

- `applyRemovalPolicy(policy?: RemovalPolicy, options?: RemovalPolicyOptions): void` — Sets the deletion policy of the resource based on the removal policy specified.

  The Removal Policy controls what happens to this resource when it stops
  being managed by CloudFormation, either because you've removed it from the
  CDK application or because you've made a change that requires the resource
  to be replaced.

  The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
  account for data recovery and cleanup later (`RemovalPolicy.RETAIN`). In some
  cases, a snapshot can be taken of the resource prior to deletion
  (`RemovalPolicy.SNAPSHOT`). A list of resources that support this policy
  can be found in the following link:

- `arnForDataSet(resource: IDataSetRef): string` (static)

- `cfnPropertyName(cdkPropertyName: string): string`

- `getAtt(attributeName: string, typeHint?: ResolutionTypeHint): Reference` — Returns a token for an runtime attribute of this resource.

  Ideally, use generated attribute accessors (e.g. `resource.arn`), but this can be used for future compatibility
  in case there is no generated attribute.

  **Parameters**

  - `attributeName` — The name of the attribute.

- `getMetadata(key: string): any` — Retrieve a value value from the CloudFormation Resource Metadata.

- `inspect(inspector: TreeInspector): void` — Examines the CloudFormation resource and discloses attributes.

  **Parameters**

  - `inspector` — tree inspector to collect and process attributes.

- `isCfnDataSet(x: any): boolean` (static) — Checks whether the given object is a CfnDataSet.

- `isCfnElement(x: any): boolean` (static) — Returns `true` if a construct is a stack element (i.e. part of the synthesized cloudformation template).

  Uses duck-typing instead of `instanceof` to allow stack elements from different
  versions of this library to be included in the same stack.

  **Returns:** The construct as a stack element or undefined if it is not a stack element.

- `isCfnResource(x: any): boolean` (static) — Check whether the given object is a CfnResource.

- `isConstruct(x: any): boolean` (static) — Checks if `x` is a construct.

  Use this method instead of `instanceof` to properly detect `Construct`
  instances, even when the construct library is symlinked.

  Explanation: in JavaScript, multiple copies of the `constructs` library on
  disk are seen as independent, completely different libraries. As a
  consequence, the class `Construct` in each copy of the `constructs` library
  is seen as a different class, and an instance of one class will not test as
  `instanceof` the other class. `npm install` will not create installations
  like this, but users may manually symlink construct libraries together or
  use a monorepo tool: in those cases, multiple copies of the `constructs`
  library can be accidentally installed, and `instanceof` will behave
  unpredictably. It is safest to avoid using `instanceof`, and using
  this type-testing method instead.

  **Parameters**

  - `x` — Any object.

  **Returns:** true if `x` is an object created from a class which extends `Construct`.

- `obtainDependencies(): Stack | CfnResource[]` — Retrieves an array of resources and stacks this resource depends on.

  For resources depended on directly, returns the `CfnResource` object. For
  dependencies on other stacks, returns the `Stack` object. The order of the
  array is not guaranteed.

- `overrideLogicalId(newLogicalId: string): void` — Overrides the auto-generated logical ID with a specific ID.

  **Parameters**

  - `newLogicalId` — The new logical ID to use for this stack element.

- `removeDependency(target: CfnResource): void` — Use `removeResourceDependency` instead

  This can be used for resources across stacks (including nested stacks)
  and the dependency will automatically be removed from the relevant scope.

- `removeResourceDependency(target: CfnResource): void` — Indicates that this resource no longer depends on another resource.

  This can be used for resources across stacks (including nested stacks)
  and the dependency will automatically be removed from the relevant scope.

- `replaceDependency(target: CfnResource, newTarget: CfnResource): void` — Replaces one dependency with another.

  **Parameters**

  - `target` — The dependency to replace.
  - `newTarget` — The new dependency to add.

- `toString(): string` — Returns a string representation of this construct.

  **Returns:** a string representation of this resource

- `with(...mixins: IMixin[]): IConstruct` — Applies one or more mixins to this construct.

  Mixins are applied in order. The list of constructs is captured at the
  start of the call, so constructs added by a mixin will not be visited.
  Use multiple `with()` calls if subsequent mixins should apply to added
  constructs.
